<?php

namespace WHMCS\Module\Addon\Smsir;

use WHMCS\Database\Capsule;

class Admin {

    public function GetAdmins() {
        $admins = Capsule::table('smsir_admins');
        return $admins->get();
    }

    public function GetWhmcsAdmins() {
        return Capsule::table('tbladmins')->get();
    }

    public function GetAdminWithPermission($permissions = []){
        $admins = Capsule::table('smsir_admins');
        foreach ($permissions as $permission) {
            $admins->where('events', 'LIKE', '%'.$permission.'%');
        }
        return $admins->get();
    }

    Public function AddAdmin($vars) {
        try {
            Capsule::table('smsir_admins')->insert([
                'admin_id' => $_POST['admin_id'],
                'events' => implode(',',$_POST['events']),
                'phone' => str_replace(' ', '',$_POST['phone']),
            ]);
            return ['status' => 1, 'message' => $vars['_lang']['admin-add-success']];
        }catch (\Exception $e){
            return ['status' => 0, 'message' => $vars['_lang']['admin-add-failed'] . $e->getMessage()];
        }
    }

    public function GetAdmin($id) {
        $admin = Capsule::table('tbladmins')->where('id', '=', $id)->first();
        $smsir_admin = Capsule::table('smsir_admins')->where('admin_id', '=', $id)->first();
        return array_merge($admin, $smsir_admin);
    }

    public function UpdateAdmin($id, $vars) {
        try {
            Capsule::table('smsir_admins')->where('id','=', $id)->insert([
                'admin_id' => $_POST['admin_id'],
                'events' => implode(',',$_POST['events']),
                'phone' => str_replace(' ', '',$_POST['phone']),
            ]);
            return ['status' => 1, 'message' => $vars['_lang']['admin-update-success']];
        }catch (\Exception $e){
            return ['status' => 0, 'message' => $vars['_lang']['admin-update-failed'] . $e->getMessage()];
        }
    }

    public function DeleteAdmin($id, $vars) {
        try {
            Capsule::table('smsir_admins')->where('id','=',$id)->delete();
            return ['status' => 1, 'message' => $vars['_lang']['admin-delete-success']];
        }catch (\Exception $e){
            return ['status' => 0, 'message' => $vars['_lang']['admin-delete-failed'] . $e->getMessage()];
        }
    }

}
