<?php

namespace WHMCS\Module\Addon\Smsir;

class Send {

    public function SendSms($vars) {
        $phones = explode(',',$_POST['phones']);
        $message = $_POST['message'];
        return $this->SendBulkSms($phones, $message);
    }

    public function SendFastSms($phone, $template_number, $parameters = []) {
        $url = '/send/verify';
        $params = [
            'TemplateId' => $template_number,
            'Mobile' => $phone,
            'Parameters' => $parameters
        ];
        return $this->cUrl($url, $params);
    }

    public function SendBulkSms($phones = [], $message = null) {
        $url = '/send/bulk';
        $params = [
            'MessageText' => $message,
            'Mobiles' => $phones,
        ];
        return $this->cUrl($url, $params);
    }

    private function cUrl($url, $params = array() , $method = 'POST', $headers = array() ) {
        $setting = (new Setting())->GetSettings();
        $headers[] = 'X-API-KEY: '. $setting['api_key'];
        $headers[] = 'Content-Type:application/json';
        $domain = "https://api.sms.ir/v1";
        $handler = curl_init($domain.$url);
        $params['lineNumber'] = (int) $setting['line_number'];
        curl_setopt($handler, CURLOPT_CONNECTTIMEOUT, 5);
        curl_setopt($handler, CURLOPT_TIMEOUT, 20);
        curl_setopt($handler, CURLOPT_CUSTOMREQUEST, $method);
        curl_setopt($handler, CURLOPT_HTTPHEADER, $headers);
        if($method == 'POST') curl_setopt($handler, CURLOPT_POSTFIELDS, json_encode($params));
        curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($handler);
        return json_decode($result, false, 512, JSON_THROW_ON_ERROR);
    }
}
