<?php

namespace WHMCS\Module\Addon\Smsir;

use WHMCS\Database\Capsule;

class Template {
    public function CreateTemplate($vars) {
        try {
            Capsule::table('smsir_templates')->insert([
                'name' => $_POST['template_name'],
                'on' => $_POST['on'],
                'user_fast_send' => $_POST['user_fast_send'],
                'user_message' => $_POST['user_message'],
                'user_message_number' => $_POST['user_message_number'],
                'admin_fast_send' => $_POST['admin_fast_send'],
                'admin_message' => $_POST['admin_message'],
                'admin_message_number' => $_POST['admin_message_number'],
            ]);
            return ['status' => 1, 'message' => $vars['_lang']['template-creation-success']];
        }catch (\Exception $e){
            return ['status' => 0, 'message' => $vars['_lang']['template-creation-failed'] . $e->getMessage()];
        }
    }

    public function UpdateTemplate($id, $vars) {
        try {
            Capsule::table('smsir_templates')->where('id','=',$id)->update([
                'name' => $_POST['template_name'],
                'on' => $_POST['on'],
                'user_fast_send' => $_POST['user_fast_send'],
                'user_message' => $_POST['user_message'],
                'user_message_number' => $_POST['user_message_number'],
                'admin_fast_send' => $_POST['admin_fast_send'],
                'admin_message' => $_POST['admin_message'],
                'admin_message_number' => $_POST['admin_message_number'],
            ]);
            return ['status' => 1, 'message' => $vars['_lang']['template-update-success']];
        }catch (\Exception $e){
            return ['status' => 0, 'message' => $vars['_lang']['template-update-failed'] . $e->getMessage()];
        }
    }

    public function GetTemplatesByEvents($template_name) {
        return Capsule::table('smsir_templates')->where('on','=',$template_name)->get();
    }

    public function GetTemplates() {
        return Capsule::table('smsir_templates')->get();
    }

    public function GetTemplate($template_id) {
        return Capsule::table('smsir_templates')->where('id', '=', $template_id)->first();
    }

    public function DeleteTemplate($template_id, $vars) {
        try {
            Capsule::table('smsir_templates')->where('id', '=', $template_id)->delete();
            return ['status' => 1, 'message' => $vars['_lang']['template-delete-success']];
        }catch (\Exception $e) {
            return ['status' => 0, 'message' => $vars['_lang']['template-delete-failed'] . $e->getMessage()];
        }
    }
}
